package com.supervision.knowsub.service.impl;

import com.baomidou.mybatisplus.extension.conditions.query.LambdaQueryChainWrapper;
import com.supervision.knowsub.domain.UserInfo;
import com.supervision.knowsub.entity.vo.homepage.MyKnowledgeStatisticsResVO;
import com.supervision.knowsub.enums.StatusEnum;
import com.supervision.knowsub.exception.BusinessException;
import com.supervision.knowsub.model.Knowledge;
import com.supervision.knowsub.model.SystemUser;
import com.supervision.knowsub.service.HomepageService;
import com.supervision.knowsub.service.KnowledgeService;
import com.supervision.knowsub.service.SystemUserService;
import com.supervision.knowsub.util.UserUtil;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Slf4j
@Service
@RequiredArgsConstructor
public class HomepageServiceImpl implements HomepageService {

    private final KnowledgeService knowledgeService;

    private final SystemUserService systemUserService;

    @Override
    public MyKnowledgeStatisticsResVO queryMyKnowledgeStatistics() {
        UserInfo user = UserUtil.getUser();
        SystemUser systemUser = systemUserService.getOptById(user.getId()).orElseThrow(() -> new BusinessException("未找到用户"));
        MyKnowledgeStatisticsResVO resVO = new MyKnowledgeStatisticsResVO();
        resVO.setUserName(user.getUsername());
        resVO.setLastLoginTime(systemUser.getRecentLoginTime());
        // 首先查询所有通过
        Long passTotalCount = knowledgeService.lambdaQuery().eq(Knowledge::getStatus, StatusEnum.PASS.getStatus()).count();
        // 然后找到属于自己的知识的草稿
        Long count1 = knowledgeService.lambdaQuery().ne(Knowledge::getStatus, StatusEnum.PASS.getStatus())
                .eq(Knowledge::getDraftBelongUserId, user.getId()).count();
//        resVO.setKnowledgeCount();
//        resVO.setWaitProcessCount();
//        resVO.setPassProcessCount();
//        resVO.setRejectProcessCount();
//        resVO.setInvalidProcessCount();




        return null;
    }
}
